/**
 * This class was created by <SoundLogic>. It's distributed as
 * part of the Botania Mod. Get the Source Code in github:
 * https://github.com/Vazkii/Botania
 * 
 * Botania is Open Source and distributed under the
 * Botania License: http://botaniamod.net/license.php
 * 
 * File Created @ [Jul 4, 2014, 10:38:50 PM (GMT)]
 */
package xyz.brassgoggledcoders.boilerplate.lib.common.manual.page;

import java.lang.reflect.Constructor;

import net.minecraft.client.Minecraft;
import net.minecraft.client.renderer.GlStateManager;
import net.minecraft.client.renderer.OpenGlHelper;
import net.minecraft.client.renderer.RenderHelper;
import net.minecraft.entity.Entity;
import net.minecraft.entity.EntityList;
import net.minecraft.util.MathHelper;
import net.minecraft.world.World;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;
import xyz.brassgoggledcoders.boilerplate.lib.common.manual.IGuiLexiconEntry;
import xyz.brassgoggledcoders.boilerplate.lib.common.manual.LexiconPage;

public class PageEntity extends LexiconPage{

	Entity dummyEntity;
	int relativeMouseX, relativeMouseY;
	boolean tooltipEntity;
	int size;
	Constructor<?> entityConstructor;

	public PageEntity(String unlocalizedName, String entity, int size) {
		super(unlocalizedName);
		Class<?> EntityClass = (Class<?>) EntityList.field_75625_b.get(entity);
		this.size = size;
		try {
			entityConstructor = EntityClass.getConstructor(World.class);
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	@Override
	@SideOnly(Side.CLIENT)
	public void renderScreen(IGuiLexiconEntry gui, int mx, int my) {
		prepDummy();
		int text_x = gui.getLeft() + 16;
		int text_y = gui.getTop() + gui.getHeight() - 40;
		int entity_scale = getEntityScale(size);
		int entity_x = gui.getLeft() + gui.getWidth() / 2;
		int entity_y = gui.getTop() + gui.getHeight() / 2 + MathHelper.func_76141_d(dummyEntity.field_70131_O * entity_scale / 2);

		renderEntity(gui, dummyEntity, entity_x, entity_y, entity_scale, dummyEntity.field_70173_aa * 2);

		PageText.renderText(text_x, text_y, gui.getWidth() - 30, gui.getHeight(), getUnlocalizedName());
	}

	@SideOnly(Side.CLIENT)
	public int getEntityScale(int targetSize) {
		float entity_size = dummyEntity.field_70130_N;

		if(dummyEntity.field_70130_N < dummyEntity.field_70131_O)
			entity_size = dummyEntity.field_70131_O;

		return MathHelper.func_76141_d(size / entity_size);

	}

	@Override
	public void updateScreen() {
		prepDummy();
		dummyEntity.field_70173_aa++;
	}

	@SideOnly(Side.CLIENT)
	public void renderEntity(IGuiLexiconEntry gui, Entity entity, int x, int y, int scale, float rotation) {
		dummyEntity.field_70170_p = Minecraft.func_71410_x() != null ? Minecraft.func_71410_x().field_71441_e : null;

		GlStateManager.func_179142_g();
		GlStateManager.func_179094_E();
		GlStateManager.func_179109_b(x, y, 50.0F);
		GlStateManager.func_179152_a(-scale, scale, scale);
		GlStateManager.func_179114_b(180.0F, 0.0F, 0.0F, 1.0F);
		GlStateManager.func_179114_b(rotation, 0.0F, 1.0F, 0.0F);
		RenderHelper.func_74519_b();
		Minecraft.func_71410_x().func_175598_ae().field_78735_i = 180.0F;
		Minecraft.func_71410_x().func_175598_ae().func_147940_a(entity, 0.0D, 0.0D, 0.0D, 0.0F, 1.0F);
		GlStateManager.func_179121_F();
		RenderHelper.func_74518_a();
		GlStateManager.func_179101_C();
		OpenGlHelper.func_77473_a(OpenGlHelper.field_77476_b);
		GlStateManager.func_179090_x();
		OpenGlHelper.func_77473_a(OpenGlHelper.field_77478_a);

		if(relativeMouseX >= x - dummyEntity.field_70130_N * scale / 2 - 10  && relativeMouseY >= y - dummyEntity.field_70131_O * scale - 20 && relativeMouseX <= x + dummyEntity.field_70130_N * scale / 2 + 10 && relativeMouseY <= y + 20)
			tooltipEntity = true;
	}

	public void prepDummy() {
		if(dummyEntity == null || dummyEntity.field_70128_L) {
			try {
				dummyEntity = (Entity) entityConstructor.newInstance(Minecraft.func_71410_x().field_71441_e);
			} catch (Exception e) {
				e.printStackTrace();
			}
		}
	}
}
