/**
 * This class was created by <Vazkii>. It's distributed as
 * part of the Botania Mod. Get the Source Code in github:
 * https://github.com/Vazkii/Botania
 * 
 * Botania is Open Source and distributed under the
 * Botania License: http://botaniamod.net/license.php
 * 
 * File Created @ [Feb 8, 2014, 2:46:36 PM (GMT)]
 */
package xyz.brassgoggledcoders.boilerplate.lib.common.manual.page;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.List;

import org.lwjgl.input.Mouse;
import org.lwjgl.opengl.GL11;

import net.minecraft.client.Minecraft;
import net.minecraft.client.gui.GuiScreen;
import net.minecraft.client.renderer.GlStateManager;
import net.minecraft.client.renderer.RenderHelper;
import net.minecraft.client.renderer.entity.RenderItem;
import net.minecraft.item.ItemStack;
import net.minecraft.util.EnumChatFormatting;
import net.minecraft.util.StatCollector;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;
import xyz.brassgoggledcoders.boilerplate.lib.client.manual.GuiLexiconEntry;
import xyz.brassgoggledcoders.boilerplate.lib.common.manual.IGuiLexiconEntry;
import xyz.brassgoggledcoders.boilerplate.lib.common.manual.ILexicon;
import xyz.brassgoggledcoders.boilerplate.lib.common.manual.LexiconPage;
import xyz.brassgoggledcoders.boilerplate.lib.common.manual.LexiconRecipeMappings;
import xyz.brassgoggledcoders.boilerplate.lib.common.manual.LexiconRecipeMappings.EntryData;

public class PageRecipe extends LexiconPage {

	int relativeMouseX, relativeMouseY;
	ItemStack tooltipStack, tooltipContainerStack;
	boolean tooltipEntry;

	static boolean mouseDownLastTick = false;

	public PageRecipe(String unlocalizedName) {
		super(unlocalizedName);
	}

	@Override
	@SideOnly(Side.CLIENT)
	public void renderScreen(IGuiLexiconEntry gui, int mx, int my) {
		relativeMouseX = mx;
		relativeMouseY = my;

		renderRecipe(gui, mx, my);

		int width = gui.getWidth() - 30;
		int height = gui.getHeight();
		int x = gui.getLeft() + 16;
		int y = gui.getTop() + height - 40;
		PageText.renderText(x, y, width, height, getUnlocalizedName());

		if(tooltipStack != null) {
			List<String> tooltipData = tooltipStack.func_82840_a(Minecraft.func_71410_x().field_71439_g, false);
			List<String> parsedTooltip = new ArrayList<>();
			boolean first = true;

			for(String s : tooltipData) {
				String s_ = s;
				if(!first)
					s_ = EnumChatFormatting.GRAY + s;
				parsedTooltip.add(s_);
				first = false;
			}

			xyz.brassgoggledcoders.boilerplate.lib.client.manual.RenderHelper.renderTooltip(mx, my, parsedTooltip);

			int tooltipY = 8 + tooltipData.size() * 11;

			if(tooltipEntry) {
				xyz.brassgoggledcoders.boilerplate.lib.client.manual.RenderHelper.renderTooltipOrange(mx, my + tooltipY, Collections.singletonList(EnumChatFormatting.GRAY + StatCollector.func_74838_a("botaniamisc.clickToRecipe")));
				tooltipY += 18;
			}

			if(tooltipContainerStack != null)
				xyz.brassgoggledcoders.boilerplate.lib.client.manual.RenderHelper.renderTooltipGreen(mx, my + tooltipY, Arrays.asList(EnumChatFormatting.AQUA + StatCollector.func_74838_a("botaniamisc.craftingContainer"), tooltipContainerStack.func_82833_r()));
		}

		tooltipStack = tooltipContainerStack = null;
		tooltipEntry = false;
		GlStateManager.func_179084_k();
		mouseDownLastTick = Mouse.isButtonDown(0);
	}

	@SideOnly(Side.CLIENT)
	public void renderRecipe(IGuiLexiconEntry gui, int mx, int my) {
		// NO-OP
	}

	@SideOnly(Side.CLIENT)
	public void renderItemAtAngle(IGuiLexiconEntry gui, float angle, ItemStack stack) {
		if(stack == null || stack.func_77973_b() == null)
			return;

		ItemStack workStack = stack.func_77946_l();

		if(workStack.func_77952_i() == Short.MAX_VALUE || workStack.func_77952_i() == -1)
			workStack.func_77964_b(0);

		angle -= 90;
		int radius = 32;
		double xPos = gui.getLeft() + Math.cos(angle * Math.PI / 180D) * radius + gui.getWidth() / 2 - 8;
		double yPos = gui.getTop() + Math.sin(angle * Math.PI / 180D) * radius + 53;

		renderItem(gui, xPos, yPos, workStack, false);
	}

	@SideOnly(Side.CLIENT)
	public void renderItemAtGridPos(IGuiLexiconEntry gui, int x, int y, ItemStack stack, boolean accountForContainer) {
		if(stack == null || stack.func_77973_b() == null)
			return;
		stack = stack.func_77946_l();

		if(stack.func_77952_i() == Short.MAX_VALUE)
			stack.func_77964_b(0);

		int xPos = gui.getLeft() + x * 29 + 7 + (y == 0  && x == 3 ? 10 : 0);
		int yPos = gui.getTop() + y * 29 + 24 - (y == 0 ? 7 : 0);
		ItemStack stack1 = stack.func_77946_l();
		if(stack1.func_77952_i() == -1)
			stack1.func_77964_b(0);

		renderItem(gui, xPos, yPos, stack1, accountForContainer);
	}

	@SideOnly(Side.CLIENT)
	public void renderItem(IGuiLexiconEntry gui, double xPos, double yPos, ItemStack stack, boolean accountForContainer) {
		RenderItem render = Minecraft.func_71410_x().func_175599_af();
		boolean mouseDown = Mouse.isButtonDown(0);

		GlStateManager.func_179094_E();
		GlStateManager.func_179147_l();
		GlStateManager.func_179112_b(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
		RenderHelper.func_74520_c();
		GlStateManager.func_179091_B();
		GlStateManager.func_179126_j();
		GlStateManager.func_179094_E();
		GlStateManager.func_179137_b(xPos, yPos, 0);
		render.func_180450_b(stack, 0, 0);
		render.func_180453_a(Minecraft.func_71410_x().field_71466_p, stack, 0, 0, "");
		GlStateManager.func_179121_F();
		RenderHelper.func_74518_a();
		GlStateManager.func_179121_F();

		int xpi = (int) xPos;
		int ypi = (int) yPos;
		if(relativeMouseX >= xpi && relativeMouseY >= ypi && relativeMouseX <= xpi + 16 && relativeMouseY <= ypi + 16) {
			tooltipStack = stack;

			EntryData data = LexiconRecipeMappings.getDataForStack(tooltipStack);
			ItemStack book = Minecraft.func_71410_x().field_71439_g.func_71045_bC();

			if(data != null && (data.entry != gui.getEntry() || data.page != gui.getPageOn()) && book != null && book.func_77973_b() instanceof ILexicon) {
				tooltipEntry = true;

				if(!mouseDownLastTick && mouseDown && GuiScreen.func_146272_n()) {
					GuiLexiconEntry newGui = new GuiLexiconEntry(data.entry, (GuiScreen) gui);
					newGui.page = data.page;
					Minecraft.func_71410_x().func_147108_a(newGui);
				}
			} else tooltipEntry = false;

			if(accountForContainer) {
				ItemStack containerStack = stack.func_77973_b().getContainerItem(stack);
				if(containerStack != null && containerStack.func_77973_b() != null)
					tooltipContainerStack = containerStack;
			}
		}

		GlStateManager.func_179140_f();
	}

}
